const fs = require('fs');
const path = require('path');

const initializeTranslateObject = require('../translator/translate-object');

describe('Translator module', () => {

    const translateObject = initializeTranslateObject({
        url: 'http://localhost:9000/api/',
        redis: {
            url: 'redis://localhost',
            db: 0
        }
    });

    const treeFilePath = path.join(__dirname, '..', 'mocks/files/tree.json');
    const treeFileTJOPath = path.join(__dirname, '..', 'mocks/files/tree_TJO.json');

    const treeData = JSON.parse(fs.readFileSync(treeFilePath).toString());
    const treeDataTJO = JSON.parse(fs.readFileSync(treeFileTJOPath).toString());

    it('Should return translated object equals when use asksuite-translate-json-object module', async () => {
        const defaultAttributes = ['chatTreeId', 'question', "dateEnd", "dateInit", "isLink", "holiday",  "trackId", "dialog", "intent", "tags", "goToDialog", "type", "search", "image", "registerData", "id", "subject", "to", "default", "hsystemKey", "statusRevision", "dialogNewRequest", "compareSuites", "url", "otherParams", "cupom", "typeBookingEngine"];

        const newTranslatedObject = await translateObject(treeData, 'pt-br', 'en', defaultAttributes);

        expect(newTranslatedObject).toEqual(treeDataTJO);
    }, 100000);

});
