const request = require('request');

module.exports = (config) => {

  let requester = {};

  requester.getBookingRooms = async (data) => {
    const promise = new Promise((resolve, reject) => {
      request.get({
        url: config.CRAWLER_ENDPOINT + `/generic/booking-pricing?idHotel=${data.bookingId}&checkin=${data.ArrivalDateString}&checkout=${data.DepartureDateString}&adultos=${data.AmountAdults}&criancas=${data.AmountChildren}`,
        json: true,
      }, (err, httpResponse, body) => {

        if (!err && httpResponse.statusCode === 200) {
          resolve(body);
        } else {

          const error = !err ? "There are no rooms available for this hotel at booking" : err;
          reject(error);

        }

      })

    });

    return promise;

  };

  const transformSearchEngineValueToNumbers = (item) => {
    const priceFiltered = parseFloat(item.total.replace(/\D/g, '')) / 100;

    return priceFiltered;
  };

  const calculatePercentage = (minPriceBooking, minPriceEngine) => {
    const difference = minPriceBooking - minPriceEngine;
    const division = difference/minPriceBooking;

    return (division*100);

  };

  requester.calculateDiscountAgainstBooking = (bookingPrices, searchEnginePrices) => {

    const bookingPricesFilteredPrices = bookingPrices.map((item) => {
      return item.total;
    });

    const searchEngineFilteredPrices = searchEnginePrices.map(transformSearchEngineValueToNumbers);
    const minPriceBooking = Math.min(...bookingPricesFilteredPrices);
    //Simulates higher price to show card at chat please comment the other minPriceBooking
    //const minPriceBooking = 1300;
    const minPriceEngine = Math.min(...searchEngineFilteredPrices);

    if (minPriceBooking <= minPriceEngine) {
      return false;
    } else {

    if (((minPriceEngine - minPriceBooking) * -1) < 1){
        return false;
    }

      const resultPercentage = calculatePercentage(minPriceBooking, minPriceEngine);

      return resultPercentage;

    }
  };

  return requester;

};
