const util = require("./util");
var request = require('request');



module.exports  = function(config){

    var requester = {};

    requester.list = function () {

        var promise = new Promise(function (resolve, reject) {

            request.get({
                url: config.INFOCHAT_DATA_SERVER + "/chattrees",
                json: true,
                headers: {
                    'Authorization': config.USER_TOKEN
                }
            }, function (err, httpResponse, body) {

                if (!err) {

                    console.log("######################");
                    //console.log(body);
                    resolve(body);
                } else {
                    console.log("erro ao listar dados", err);
                    reject(err);
                }

            })

        });

        return promise;
    }


    requester.listCompanies = function () {

        var promise = new Promise(function (resolve, reject) {


            request.get({
                url: config.INFOCHAT_DATA_SERVER + "/companies",
                json: true,
                headers: {
                    'Authorization': config.USER_TOKEN
                }
            }, function (err, httpResponse, body) {

                if (!err) {
                    resolve(body);
                } else {
                    console.log("erro ao listar dados", err);
                    reject(err);
                }

            })

        });


        return promise;
    }


    requester.findCompany = function (id) {

        var promise = new Promise(function (resolve, reject) {

            request.get({
                url: config.INFOCHAT_DATA_SERVER + "/companies/"+id,
                json: true,
            }, function (err, httpResponse, body) {

                if (!err) {
                    resolve(body);
                } else {
                    console.log("erro ao listar dados", err);
                    reject(err);
                }

            })

        });


        return promise;
    }


    requester.findTree = function (id) {

        var promise = new Promise(function (resolve, reject) {

            request.get({
                url: config.INFOCHAT_DATA_SERVER + "/chattrees/"+id,
                json: true,
                headers: {
                    'Authorization': config.USER_TOKEN
                }
            }, function (err, httpResponse, body) {

                if (!err) {

                    try{
                        resolve(body);
                    }catch (e){
                        console.log(e);
                        reject(e);
                    }


                } else {
                    console.log("erro ao listar dados", err);
                    reject(err);
                }

            })

        });


        return promise;
    }


    requester.findTreeByCompanyId = function (treeId) {

        var promise = new Promise(function (resolve, reject) {

            request.get({
                url: config.INFOCHAT_DATA_SERVER + "/chattrees/"+treeId+"/findByCompanyId",
                json: true,
                headers: {
                    'Authorization': config.USER_TOKEN
                }
            }, function (err, httpResponse, body) {

                if (!err) {
                    resolve(body);
                } else {
                    console.log("erro ao listar dados", err);
                    reject(err);
                }

            })

        });


        return promise;
    }


    requester.listKeywordsExpressions = function () {

        return new Promise(function (resolve, reject) {
            request.get({
                url: config.INFOCHAT_DATA_SERVER + "/keywordintents",
                json: true,
            }, function (err, httpResponse, body) {

                if (!err) {

                    try {
                        resolve(body);
                    } catch (e) {
                        console.log(e);
                        reject(e);
                    }

                } else {
                    console.log("erro ao listar dados", err);
                    reject(err);
                }

            })

        });

    }


    requester.findBookingEngineByType = function (type) {

        var promise = new Promise(function (resolve, reject) {

            request.get({
                url: config.INFOCHAT_DATA_SERVER + "/bookingengines/findByType/"+type,
                json: true,
                headers: {
                    'Authorization': config.USER_TOKEN
                }
            }, function (err, httpResponse, body) {

                if (!err) {
                    resolve(body);
                } else {
                    console.log("erro ao listar dados", err);
                    reject(err);
                }

            })

        });


        return promise;
    }


    requester.finishConversation = function (conversationId) {

        var promise = new Promise(function (resolve, reject) {

            request.get({
                url: config.INFOCHAT_DATA_SERVER + "/conversation/finishConversation/"+conversationId,
                headers: {
                    'Authorization': config.USER_TOKEN
                }
            }, function (err, httpResponse, body) {

                if (!err) {

                    console.log("finishedconversation", body);
                    resolve(body);
                } else {
                    console.log("erro ao realizar o finish", err);
                    reject(err);
                }

            })

        });

        return promise;
    };

    requester.markRequestPrice = function (conversationId) {
        return new Promise(function (resolve, reject) {
            request.post({
                url: config.INFOCHAT_DATA_SERVER + "/conversation/setRequestedPrice/" + conversationId,
                headers: {
                    'Authorization': config.USER_TOKEN
                }
            }, function (err, httpResponse, body) {

                if (!err && httpResponse.statusCode < 400) {
                    console.log("mark conversation request price", conversationId);
                    resolve(body);
                } else {
                    console.log("erro ao realizar o mark conversation request price", err || body);
                    reject(err);
                }

            })

        });
    };

    requester.registerQuote = function (searchData) {
        return new Promise(function (resolve, reject) {
            if(!searchData.companyId || searchData.companyId.indexOf('.') > 0) {
                resolve('test chat');
            } else {
                searchData.arrivalDate = searchData.arrivalDate ? searchData.arrivalDate + 'T06:00:00.000Z' : null;
                searchData.departureDate = searchData.departureDate ? searchData.departureDate + 'T06:00:00.000Z' : null;
                if (searchData.searchResult) {
                    searchData = Object.assign(searchData, util.getPriceExtremes(searchData.searchResult));
                }

                request.post({
                    url: config.INFOCHAT_DATA_SERVER + "/conversation/registerQuote",
                    headers: {
                        'Authorization': config.USER_TOKEN
                    },
                    json: searchData
                }, function (err, httpResponse, body) {

                    if (!err) {
                        resolve(body);
                    } else {
                        reject(err);
                    }

                });
            }
        });
    };


    return requester;
};




