const fallbackIntent = require('./fallbackIntent');
const Util = require('../util');

class IntentResolver {
    constructor(intents, companyId, text) {
        this.intents = intents;
        this.companyId = companyId;
        this.text = text ? text : '';
    }

    findDialogByIntent(intent) {
        let intentBot = this.intents.find(item => {
            if(item) {
                return item.intent === intent;
            }
        });

        if (!intentBot || intentBot.intent === fallbackIntent.normal.intent){
            let msg = Util.replaceIfIsPhrase(this.text);
            msg = !msg ? this.text.toLowerCase() : msg;

            const notUnderstandable = (msg.length <= 2 && !Util.isNumeric(msg)) || Util.existsletterCount(msg, 3);
            if (notUnderstandable) {
                intentBot = this.intents.find(item => {
                    return item.intent === fallbackIntent.naoentendivel.intent;
                });
            } else { // Fallback
                intentBot = {};
                intentBot.intent = fallbackIntent.normal.intent;
                intentBot.dialog = this.companyId + fallbackIntent.normal.dialogSuffix;
            }
        }

        return intentBot;
    }

    static queryTextMaxLengthExceededDialog(companyId) {
        let intent = {};
        intent.intent = fallbackIntent.grande.intent;
        intent.dialog = companyId + fallbackIntent.grande.dialogSuffix;
        return intent;
    }

    static textNotDefinedDialog(companyId) {
        let intent = {};
        intent.intent = fallbackIntent.normal.intent;
        intent.dialog = companyId + fallbackIntent.normal.dialogSuffix;
        return intent;
    }
}

module.exports = IntentResolver;
